// WdbgExt.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "WdbgExt.h"
#include <ntverp.h>


//
// globals
//
EXT_API_VERSION         ApiVersion = { (VER_PRODUCTVERSION_W >> 8), (VER_PRODUCTVERSION_W & 0xff), EXT_API_VERSION_NUMBER64, 0 };
WINDBG_EXTENSION_APIS   ExtensionApis;
ULONG SavedMajorVersion;
ULONG SavedMinorVersion;
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// This is an example of an exported variable
WDBGEXT_API int nWdbgExt=0;

// This is an example of an exported function.
WDBGEXT_API int fnWdbgExt(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see WdbgExt.h for the class definition
CWdbgExt::CWdbgExt()
{ 
	return; 
}

VOID WINAPI
WinDbgExtensionDllInit(
    PWINDBG_EXTENSION_APIS lpExtensionApis,
    USHORT MajorVersion,
    USHORT MinorVersion
    )
{
    ExtensionApis = *lpExtensionApis;

    SavedMajorVersion = MajorVersion;
    SavedMinorVersion = MinorVersion;

    return;
}

LPEXT_API_VERSION WINAPI
ExtensionApiVersion(
    VOID
    )
{
    //
    // ExtensionApiVersion should return EXT_API_VERSION_NUMBER64 in order for APIs
    // to recognize 64 bit addresses.  KDEXT_64BIT also has to be defined before including
    // wdbgexts.h to get 64 bit headers for WINDBG_EXTENSION_APIS
    //
    return &ApiVersion;
}

//
// Routine called by debugger after load
//
VOID WINAPI
CheckVersion(
    VOID
    )
{
    return;
}
//
// Extension to say hello
//
DECLARE_API ( hello ) 
{
     dprintf("Hi, WinDBG is great, no %d!\n", GetExpression(args));
}

/*
  A built-in help for the extension dll
*/

DECLARE_API ( help ) 
{
    dprintf("Help for WdbgExt.dll\n"
            "   hello              - say hello\n"
            "   help               - Shows this help\n"
            );

}
